package info.tonda.pg.partygame;

import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.CountDownTimer;
import android.support.v7.app.ActionBar;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.RadioButton;
import android.widget.TextView;
import android.widget.Toast;

import com.google.gson.Gson;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Random;

/**
 * An example full-screen activity that shows and hides the system UI (i.e.
 * status bar and navigation/system bar) with user interaction.
 */
public class GameActivity extends PartyBaseActivity {
    private static boolean countDownRunnig = false;


    final Context context = this;
    ArrayList<GameObjective> objectives;
    private int level;
    private int gameType;
    StorageHelper pref;
    int teamCount;
    long gameTime;
    int gameRoundTotal;
    public static int currentGameRound = 1;
    CountDownTimer timer;

    //for objective dialog
    String gameTypeText;
    int imageResource;
    String gameObjective;

    //current team
    int currentTeam;
    String currentTeamName;
    int currentTeamScore;

    /**
     * Whether or not the system UI should be auto-hidden after
     * {@link #AUTO_HIDE_DELAY_MILLIS} milliseconds.
     */
    private static final boolean AUTO_HIDE = true;

    /**
     * If {@link #AUTO_HIDE} is set, the number of milliseconds to wait after
     * user interaction before hiding the system UI.
     */
    private static final int AUTO_HIDE_DELAY_MILLIS = 3000;

    /**
     * Some older devices needs a small delay between UI widget updates
     * and a change of the status and navigation bar.
     */
    private static final int UI_ANIMATION_DELAY = 300;
    private final Handler mHideHandler = new Handler();
    private View mContentView;
    private final Runnable mHidePart2Runnable = new Runnable() {
        @SuppressLint("InlinedApi")
        @Override
        public void run() {
            // Delayed removal of status and navigation bar

            // Note that some of these constants are new as of API 16 (Jelly Bean)
            // and API 19 (KitKat). It is safe to use them, as they are inlined
            // at compile-time and do nothing on earlier devices.
            mContentView.setSystemUiVisibility(View.SYSTEM_UI_FLAG_LOW_PROFILE
                    | View.SYSTEM_UI_FLAG_FULLSCREEN
                    | View.SYSTEM_UI_FLAG_LAYOUT_STABLE
                    | View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY
                    | View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
                    | View.SYSTEM_UI_FLAG_HIDE_NAVIGATION);
        }
    };
    private View mControlsView;
    private final Runnable mShowPart2Runnable = new Runnable() {
        @Override
        public void run() {
            // Delayed display of UI elements
            ActionBar actionBar = getSupportActionBar();
            if (actionBar != null) {
                actionBar.show();
            }
            mControlsView.setVisibility(View.VISIBLE);
        }
    };
    private boolean mVisible;
    private final Runnable mHideRunnable = new Runnable() {
        @Override
        public void run() {
            hide();
        }
    };
    /**
     * Touch listener to use for in-layout UI controls to delay hiding the
     * system UI. This is to prevent the jarring behavior of controls going away
     * while interacting with activity UI.
     */
    private final View.OnTouchListener mDelayHideTouchListener = new View.OnTouchListener() {
        @Override
        public boolean onTouch(View view, MotionEvent motionEvent) {
            if (AUTO_HIDE) {
                delayedHide(AUTO_HIDE_DELAY_MILLIS);
            }
            return false;
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                WindowManager.LayoutParams.FLAG_FULLSCREEN);
        getSupportActionBar().hide();
        setContentView(R.layout.activity_game);

        pref = new StorageHelper(context);
        teamCount = pref.getInt("teamCount");
        gameTime =  (long) pref.getInt("gameTime");
        gameRoundTotal = pref.getInt("gameRound")*teamCount;

        chooseCurrentTeam();
        getDialog().show();

        mVisible = true;
        mContentView = findViewById(R.id.game_content);
    }

    public void chooseCurrentTeam(){
        //GET saved values
        ArrayList<String> teamList =  pref.getArrayList("TeamList");
        this.currentTeam = pref.getInt("currentTeam");

        this.currentTeamName = teamList.get(currentTeam);
        this.currentTeamScore = pref.getInt(this.currentTeamName);

        //update saved values
        pref.setInt("currentTeam", (currentTeam+1)%teamCount);
    }

    //Choose LEVEL
    //dialog
    public AlertDialog getDialog(){
        // get prompts.xml view
        LayoutInflater layoutInflater = LayoutInflater.from(context);
        //set UI of dialog
        View promptView = layoutInflater.inflate(R.layout.choose_level, null);

        //BUILD dialog
        AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(context);
        // set prompts.xml to be the layout file of the alertdialog builder
        alertDialogBuilder.setView(promptView);



        //get controls
        TextView teamName = (TextView) promptView.findViewById(R.id.teamName);
        TextView currentScore = (TextView) promptView.findViewById(R.id.currScore);
        //set controls by saved values
        teamName.setText(this.currentTeamName);
        currentScore.setText(""+this.currentTeamScore);



        // setup a dialog window
        alertDialogBuilder
                .setCancelable(false)
                .setPositiveButton(R.string.btn_ok, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        if(level == 0) level = 3;
                        setObjective();
                    }
                });
        // create an alert dialog
        AlertDialog alertD = alertDialogBuilder.create();
        return alertD;
    }

    //Choose LEVEL
    //onChange event
    public void onRadioButtonClicked(View view) {
        // Is the button now checked?
        boolean checked = ((RadioButton) view).isChecked();

        // Check which radio button was clicked
        switch(view.getId()) {
            case R.id.level_3:
                if (checked)
                    this.level = 3;
                    break;
            case R.id.level_4:
                if (checked)
                    this.level = 4;
                    break;
            case R.id.level_5:
                if (checked)
                    this.level = 5;
                    break;
        }
    }

    //Objective
    private GameObjective getRandomObjective(int typeID, int level){
        loadGameObjectives();
        Random r = new Random();
        Gson gson = new Gson();
        ArrayList<GameObjective> objectiveList = new ArrayList<GameObjective>();


        for(GameObjective obj : this.objectives){
            if(obj.getTypeID() == typeID && obj.getPoints() == level){
                objectiveList.add(obj);
            }
        }

        int index = r.nextInt(objectiveList.size());
        return objectiveList.get(index);
    }


    private void setObjective(){
        Random r = new Random();
        GameObjective go;

        this.gameType = r.nextInt(3 - 1 + 1) + 1;

        TextView game = (TextView) findViewById(R.id.game_content);

        go = getRandomObjective(this.gameType, this.level);
        gameObjective = go.getObjective();

        switch (this.gameType) {
            case 1:
                game.setBackgroundResource(R.color.pg_paint);
                this.gameTypeText = getString(R.string.game_type_paint);
                this.imageResource = R.drawable.drawing;
                break;
            case 2:
                game.setBackgroundResource(R.color.pg_talk);
                this.gameTypeText = getString(R.string.game_type_talk);
                this.imageResource = R.drawable.speaking;
                break;
            default:
                game.setBackgroundResource(R.color.pg_pantomima);
                this.gameTypeText = getString(R.string.game_type_pantomima);
                this.imageResource = R.drawable.pantonima;
                break;
        }

        getObjectiveWindow();
    }


    public void getObjectiveWindow(View v) {getObjectiveWindow();}
    public void getObjectiveWindow() {
        LayoutInflater layoutInflater = LayoutInflater.from(context);
        //set UI of dialog
        View promptView = layoutInflater.inflate(R.layout.game_objective, null);

        //BUILD dialog
        AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(context);
        // set prompts.xml to be the layout file of the alertdialog builder
        alertDialogBuilder.setView(promptView);
        TextView gameType = (TextView) promptView.findViewById(R.id.gameType);
        TextView gamePoints = (TextView) promptView.findViewById(R.id.gamePoint);
        ImageView gameImage = (ImageView) promptView.findViewById(R.id.gameImage);
        TextView gameObjective = (TextView) promptView.findViewById(R.id.gameObjective);

        gameType.setText((CharSequence) gameTypeText);
        gamePoints.setText((CharSequence) (this.level+" "+getString(R.string.game_points_2)));
        gameObjective.setText((CharSequence) this.gameObjective);
        gameImage.setImageResource(imageResource);

        // setup a dialog window
        alertDialogBuilder
                .setCancelable(false)
                .setPositiveButton(R.string.game_objective_done, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {

                    }
                });

        // create an alert dialog
        AlertDialog alertD = alertDialogBuilder.create();
        alertD.show();
    }


    public void toggleTimer(View v){
        if(!this.countDownRunnig){
            countDownRunnig = true;
            timer = getTimer(gameTime, R.id.game_content).start();
        }
    }

     public CountDownTimer getTimer(long time, final int textElement){
         TextView timerText = (TextView) findViewById(textElement);
         try {
             timerText.setTextColor(getResources().getColor(R.color.white));
         } catch (NullPointerException e) {
            //nothing here
         }
         return new CountDownTimer(time, 1000) {
            TextView timerText = (TextView) findViewById(textElement);
            public void onTick(long millisUntilFinished) {
                timerText.setText("" + millisUntilFinished / 1000);
            }

            public void onFinish() {
                timerText.setText(getString(R.string.game_over));
                //blink(350, textElement);
                blinkText(2000, 350, textElement);
            }
        };
    }

    private void blinkText(long time, long delay, final int textElement) {
        new CountDownTimer(time, delay) {
            TextView timerText = (TextView) findViewById(textElement);
            @Override
            public void onTick(long millisUntilFinished) {
                if (timerText.getCurrentTextColor() == Color.WHITE) {
                    timerText.setTextColor(Color.BLACK);
                } else {
                    timerText.setTextColor(Color.WHITE);
                }
            }

            @Override
            public void onFinish() {
                timerText.setTextColor(Color.WHITE);
                timerText.setTextSize(30);
                showFinishDialog(false, false);
            }
        }.start();
    }

    public void showFinishDialogWin(View v) {showFinishDialog(true, true);}
    public void showFinishDialogLoose(View v) {showFinishDialog(true, false);}
    public void showFinishDialog(boolean preOnClick, boolean win){
        final TextView timerText = (TextView) findViewById(R.id.game_content);
        AlertDialog.Builder builder = new AlertDialog.Builder(GameActivity.this);
        builder.setPositiveButton(R.string.btn_yes, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        timerText.setText(getString(R.string.game_toast_win));
                        //add score for team
                        pref.setInt(currentTeamName, currentTeamScore+level);
                        //reset timer
                        countDownRunnig = false;
                        //increase game round
                        currentGameRound++;
                        if(currentGameRound > gameRoundTotal){
                            startActivity(new Intent(context, GameResult.class));
                            currentGameRound = 1;
                        }else {
                            startActivity(new Intent(context, GameActivity.class));
                        }
                        countDownRunnig = false;
                        if(timer != null) {
                            timer.cancel();
                            timer = null;
                        }
                        finish();
                    }
                })
                .setNegativeButton(R.string.btn_no, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        timerText.setText(getString(R.string.game_toast_loose));
                        //reset timer
                        countDownRunnig = false;
                        //increase game round
                        currentGameRound++;
                        if(currentGameRound > gameRoundTotal){
                            startActivity(new Intent(context, GameResult.class));
                            currentGameRound = 1;
                        }else {
                            startActivity(new Intent(context, GameActivity.class));
                        }
                        countDownRunnig = false;
                        if(timer != null) {
                            timer.cancel();
                            timer = null;
                        }
                        finish();
                    }
                });

        if(preOnClick){
            builder.setNeutralButton(R.string.btn_continue, new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    dialog.cancel();
                }
            });
            if(win){
                builder.setMessage(R.string.game_alert_result_win);
            }else {
                builder.setMessage(R.string.game_alert_result_loose);
            }
        }else {
            builder.setMessage(R.string.game_alert_result);
        }

        builder.show();
    }


    private void blink(final long timeToBlink, final int textElement){
        final Handler handler = new Handler();
        new Thread(new Runnable() {
            @Override
            public void run() {
                try{Thread.sleep(timeToBlink);}catch (Exception e) {}
                handler.post(new Runnable() {
                    @Override
                    public void run() {
                        TextView txt = (TextView) findViewById(textElement);
                        if(txt.getCurrentTextColor() == Color.WHITE){
                            txt.setTextColor(Color.BLACK);
                        }else{
                            txt.setTextColor(Color.WHITE);
                        }
                        blink(timeToBlink, textElement);
                    }
                });
            }
        }).start();
    }

    @Override
    protected void onPostCreate(Bundle savedInstanceState) {
        super.onPostCreate(savedInstanceState);

        // Trigger the initial hide() shortly after the activity has been
        // created, to briefly hint to the user that UI controls
        // are available.
        delayedHide(100);
    }

    private void toggle() {
        if (mVisible) {
            hide();
        } else {
          // b  show();
        }
    }

    private void hide() {
        // Hide UI first
        ActionBar actionBar = getSupportActionBar();
        if (actionBar != null) {
            actionBar.hide();
        }
        mVisible = false;

        // Schedule a runnable to remove the status and navigation bar after a delay
        mHideHandler.removeCallbacks(mShowPart2Runnable);
        mHideHandler.postDelayed(mHidePart2Runnable, UI_ANIMATION_DELAY);
    }


    private void loadGameObjectives(){
        this.objectives = new ArrayList<GameObjective>();
//        Gson gson = new Gson();
        //Drawing
        objectives.add(new GameObjective("paint", 3, "Badminton"));
        objectives.add(new GameObjective("paint", 3, "Manželství po italsku"));
        objectives.add(new GameObjective("paint", 3, "Kožní vyrážka"));
        objectives.add(new GameObjective("paint", 4, "Poštovní holub"));
        objectives.add(new GameObjective("paint", 4, "Stojka"));
        objectives.add(new GameObjective("paint", 4, "Jehelníček"));
        objectives.add(new GameObjective("paint", 5, "Lícní kost"));
        objectives.add(new GameObjective("paint", 5, "Bakterie"));
        objectives.add(new GameObjective("paint", 5, "Slunečnicové semínko"));
        //Talking
        objectives.add(new GameObjective("talk", 3, "Tokání"));
        objectives.add(new GameObjective("talk", 3, "Detail"));
        objectives.add(new GameObjective("talk", 3, "Očistec"));
        objectives.add(new GameObjective("talk", 4, "Pošetilec"));
        objectives.add(new GameObjective("talk", 4, "Dodatečné náklady"));
        objectives.add(new GameObjective("talk", 4, "Čínský porcelán"));
        objectives.add(new GameObjective("talk", 5, "Kostní dřeň"));
        objectives.add(new GameObjective("talk", 5, "Trýznitel"));
        objectives.add(new GameObjective("talk", 5, "Kouzelný nápoj"));
        //Pantomima
        objectives.add(new GameObjective("pantomima", 3, "Spartakiáda"));
        objectives.add(new GameObjective("pantomima", 3, "Odpadkový koš"));
        objectives.add(new GameObjective("pantomima", 3, "Řízená střela"));
        objectives.add(new GameObjective("pantomima", 4, "Příšera"));
        objectives.add(new GameObjective("pantomima", 4, "čistokrevný pes"));
        objectives.add(new GameObjective("pantomima", 4, "Čtení myšlenek"));
        objectives.add(new GameObjective("pantomima", 5, "Křižák"));
        objectives.add(new GameObjective("pantomima", 5, "Cílová rovinka"));
        objectives.add(new GameObjective("pantomima", 5, "Znaková řeč"));

//            pref.setArrayList("game_obj", go);
    }

    /*
    @SuppressLint("InlinedApi")
    private void show() {
        // Show the system bar
        mContentView.setSystemUiVisibility(View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN
                | View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION);
        mVisible = true;

        // Schedule a runnable to display UI elements after a delay
        mHideHandler.removeCallbacks(mHidePart2Runnable);
        mHideHandler.postDelayed(mShowPart2Runnable, UI_ANIMATION_DELAY);
    }
    */

    /**
     * Schedules a call to hide() in [delay] milliseconds, canceling any
     * previously scheduled calls.
     */
    private void delayedHide(int delayMillis) {
        mHideHandler.removeCallbacks(mHideRunnable);
        mHideHandler.postDelayed(mHideRunnable, delayMillis);
    }
}
