package info.tonda.pg.partygame;

import java.io.Serializable;

/**
 * Created by Neumann on 15.5.2016.
 */
public class GameObjective implements Serializable {

    public static final int PAINT = 1;
    public static final int TALK = 2;
    public static final int PANTOMIMA = 3;

    private int ID;
    private int typeID;
    private String type;
    private int points;
    private String objective;
    private String hint;

    GameObjective(String type, int points, String objective, String hint){
        this(type, points, objective);
        this.hint = hint;
    }

    GameObjective(String type, int points, String objective) {
        this.setType(type);
        this.setPoints(points);
        this.objective = objective;
    }

    public int getID() {
        return ID;
    }

    public void setID(int ID) {
        this.ID = ID;
    }

    public int getTypeID() {
        return typeID;
    }

    public void setTypeID(int typeID) {
        this.typeID = typeID;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
        switch(type) {
            case "paint":
                typeID = PAINT;
                break;
            case "talk":
                typeID = TALK;
                break;
            default:
                typeID = PANTOMIMA;
                break;
        }
    }

    public int getPoints() {
        return points;
    }

    public void setPoints(int points) {
        if(points < 1 || points > 5) {
            this.points = 3;
        }else {
            this.points = points;
        }
    }

    public String getObjective() {
        return objective;
    }

    public void setObjective(String objective) {
        this.objective = objective;
    }

    public String getHint() {
        return hint;
    }

    public void setHint(String hint) {
        this.hint = hint;
    }
}
