package info.tonda.pg.partygame;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;

import java.util.ArrayList;

public class GameResult extends PartyBaseActivity {

    final Context context = this;
    StorageHelper pref;
    String winnerTeamName = "Vítězný team";
    int winnerTeamScore = 0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_game_result);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        pref = new StorageHelper(context);

        showResult();
    }

    public void showResult(){
        final TextView winner = (TextView) findViewById(R.id.gameResultWinner);
        final TextView score = (TextView) findViewById(R.id.gameResultScore);
        ArrayList<String> teamList =  pref.getArrayList("TeamList");
        int currentScore;
        for(String team : teamList){
            currentScore = pref.getInt(team);
            if(currentScore > winnerTeamScore){
                winnerTeamScore = currentScore;
                winnerTeamName = team;
            }else if(currentScore == winnerTeamScore) {
                winnerTeamName += " + "+team;
            }
        }
        winner.setText(winnerTeamName);
        score.setText(""+winnerTeamScore);
    }

    public void endGame(View v){
        startActivity(new Intent(this, MainActivity.class));
    }

}
