package info.tonda.pg.partygame;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.support.v7.app.AppCompatActivity;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import com.google.gson.Gson;

import java.util.ArrayList;

/**
 * Created by Neumann on 21.4.2016.
 */
public class PartyBaseActivity  extends AppCompatActivity {

    final Context context = this;

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            startActivity(new Intent(this, SettingsActivity.class));
            return true;
        }else if (id == R.id.action_help) {
            startActivity(new Intent(this, HelpActivity.class));
            return true;
        }else if (id == R.id.action_about) {
            aboutInfoWindow();
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    public void aboutInfoWindow() {
        // get prompts.xml view
        LayoutInflater layoutInflater = LayoutInflater.from(context);
        //set UI of dialog
        View v = layoutInflater.inflate(R.layout.about_dialog, null);

        //BUILD dialog
        AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(context);
        alertDialogBuilder.setView(v);

        // setup a dialog window
        alertDialogBuilder
                .setCancelable(true);
        // create an alert dialog
        AlertDialog alertD = alertDialogBuilder.create();
        alertD.show();
    }


    public void shortToast(int resource) {
        shortToast(getString(R.string.game_lets_go));
    }

    public void shortToast(String text) {
        Toast.makeText(this, text, Toast.LENGTH_SHORT).show();
    }
}
