package info.tonda.pg.partygame;

        import android.app.Activity;
        import android.app.Dialog;
        import android.content.Context;
        import android.content.DialogInterface;
        import android.content.Intent;
        import android.content.SharedPreferences;
        import android.os.Bundle;
        import android.support.design.widget.FloatingActionButton;
        import android.support.design.widget.Snackbar;
        import android.support.v7.app.AlertDialog;
        import android.support.v7.app.AppCompatActivity;
        import android.support.v7.view.menu.ListMenuItemView;
        import android.support.v7.widget.Toolbar;
        import android.view.LayoutInflater;
        import android.view.View;
        import android.widget.AdapterView;
        import android.widget.ArrayAdapter;
        import android.widget.Button;
        import android.widget.EditText;
        import android.widget.ListView;
        import android.widget.Toast;

        import java.util.ArrayList;
        import java.util.HashSet;
        import java.util.List;
        import java.util.Set;
        import java.util.StringTokenizer;

public class PrepareGame extends PartyBaseActivity {

    int teamCount;
    private Button button;
    private ListView teamList;
    private ArrayAdapter<String> adapter;
    final Context context = this;
    ArrayList<String> arrayList;

    StorageHelper pref;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_prepare_game);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        pref = new StorageHelper(context);
        button = (Button) findViewById(R.id.btn_add_team);
        teamList = (ListView) findViewById(R.id.teamList);

        arrayList = pref.getArrayList("TeamList");
        adapter = new ArrayAdapter<String>(getApplicationContext(), android.R.layout.simple_spinner_item, arrayList);
        teamList.setAdapter(adapter);

        //CLICK on item
        teamList.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            public void onItemClick(AdapterView<?> parent, View view,int position, long id)
            {

                String selectedFromList = (teamList.getItemAtPosition(position).toString());
                shortToast("Deleted team: "+selectedFromList);
                arrayList.remove(position);
                pref.setArrayList("TeamList", arrayList);
                adapter.notifyDataSetChanged();
            }
        });

        //ADD NEW TEAM button
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                // get prompts.xml view
                LayoutInflater layoutInflater = LayoutInflater.from(context);
                //set UI of dialog
                View promptView = layoutInflater.inflate(R.layout.add_team_dialog, null);

                //BUILD dialog
                AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(context);
                // set prompts.xml to be the layout file of the alertdialog builder
                alertDialogBuilder.setView(promptView);
                final EditText input = (EditText) promptView.findViewById(R.id.username);
                // setup a dialog window
                alertDialogBuilder
                        .setCancelable(false)
                        .setPositiveButton(R.string.btn_ok, new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int id) {
                                // get user input and set it to result
                                String newTeam = input.getText().toString();
                                arrayList.add(newTeam);
                                pref.setArrayList("TeamList", arrayList);
                                adapter.notifyDataSetChanged();
                                dialog.dismiss();
                            }
                        })
                        .setNegativeButton(R.string.btn_cancel,
                                new DialogInterface.OnClickListener() {
                                    public void onClick(DialogInterface dialog, int id) {
                                        dialog.cancel();
                                    }
                                });

                // create an alert dialog
                AlertDialog alertD = alertDialogBuilder.create();
                alertD.show();
            }
        });
    }

    public void startGame(View v) {
        Intent i = new Intent(this, GameActivity.class);
        pref.setInt("teamCount", arrayList.size());
        pref.setInt("currentTeam", 0);
        for(String s : arrayList){
            pref.setInt(s, 0); //scores for team
        }
        startActivity(i);
    }

    public void teamInfo(View v) {
        Toast.makeText(this,  R.string.prepare_toast_team_info, Toast.LENGTH_SHORT).show();
    }

}
