package info.tonda.pg.partygame;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.CompoundButton;
import android.widget.ProgressBar;
import android.widget.Spinner;
import android.widget.Switch;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Properties;
import java.util.Set;

public class SettingsActivity extends PartyBaseActivity {

    private static final int MASTER_TIME = 6000; //standard 42000
    private static final int BEGINNER_TIME = 2*MASTER_TIME;

    private ProgressBar updateProgress;
    private int updateProgressStatus = 0;
    private Spinner spinner;
    private StorageHelper pref;
    final Context context = this;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_settings);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        pref = new StorageHelper(context);

        Switch ninja_switch = (Switch) findViewById(R.id.ninja_switch);
        if(pref.getInt("gameTime") == MASTER_TIME) ninja_switch.setChecked(true);

        ninja_switch.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if(isChecked) {
                    shortToast((MASTER_TIME/1000)+" sekund");
                    pref.setInt("gameTime", MASTER_TIME);
                } else {
                    shortToast((BEGINNER_TIME/1000)+" sekund");
                    pref.setInt("gameTime", BEGINNER_TIME);
                }
            }
        });

        addItemsOnSpinner();
    }

    public void addItemsOnSpinner() {
        Integer i = new Integer(pref.getInt("gameRound"));
        spinner = (Spinner) findViewById(R.id.spinner);
        List<Integer> list = new ArrayList<Integer>();
        list.add(1);
        list.add(2);
        list.add(10);
        list.add(20);
        list.add(30);
        list.add(40);
        ArrayAdapter<Integer> dataAdapter = new ArrayAdapter<Integer>(this,
                R.layout.spinner_item, list);
        dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner.setAdapter(dataAdapter);

        if(i != 0) {
            int spinnerPosition = dataAdapter.getPosition(i);
            spinner.setSelection(spinnerPosition);
        }
        spinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {
                Integer selected = Integer.parseInt(parentView.getItemAtPosition(position).toString());
                pref.setInt("gameRound", selected);
            }
            @Override
            public void onNothingSelected(AdapterView<?> parentView) {}
        });
    }

    public void updateData(View v) {
        Toast.makeText(this, R.string.settings_toast_update, Toast.LENGTH_LONG).show();
    }

}
