package info.tonda.pg.partygame;

import android.content.Context;
import android.content.SharedPreferences;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;

/**
 * Created by Neumann on 15.5.2016.
 */
public class StorageHelper {

    private SharedPreferences sharedPreferences;
    private SharedPreferences.Editor editor;

    public StorageHelper(Context context) {
        this.sharedPreferences = context.getSharedPreferences("Settings", Context.MODE_PRIVATE);
        this.editor = sharedPreferences.edit();
    }

    public String getString(String key) {
        return sharedPreferences.getString(key, "");
    }



    public void setString(String key, String value) {
        editor.putString(key, value);
        editor.commit();
    }

    public int getInt(String key){
        return sharedPreferences.getInt(key, 0);
    }

    public void setInt(String key, int value) {
        editor.putInt(key, value);
        editor.commit();
    }

    public ArrayList<String> getArrayList(String key){
        return new ArrayList<String>(sharedPreferences.getStringSet(key, new HashSet<String>()));
    }

    public int setArrayList(String key, ArrayList<String> list){
        Set<String> set = new HashSet<String>();
        set.addAll(list);
        editor.putStringSet(key, set);
        editor.commit();
        return set.size();
    }
}
